VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPatch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Cohort collection class"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Cohort"
Attribute VB_Ext_KEY = "Member0" ,"Cohort"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member1" ,"Stage"
Option Explicit

'Notes on collections:
'Best if any keys are textual - if varying number of units in collection
'Index for user-defined colln is 1-based

'local variable to hold collection of Stages
'Thoughts behind this were based on transfer between stages:
'Could: create Cohort in following cStage and copy features from last. Being _
sure to zero its proportional height growth increment _
(arrPop(intPatch).colCo.Item.dblGr).
'Could: not separate into stages, and just increment cStage for Cohort
' In either case, might need to split the cohort
'Advantage of character in Cohort: saves 5 objects / cell (but adds a stored integer property
'for each cohort - but then, the link between Cohort & objStage wd presumably be as large) _
    (ii) saves iteration through all Cohorts whenever fnRowSum is called _
    (iii) .Count automatically gives Cohort count
'Disadvantage - hardwires cStage as a class rather than a gradient
'but this reflects most avail data...

Private mCol As Collection
Private mintS4 As Integer, mboolDead As Boolean 'local copies

Public Function Add(Optional sKey As String) As cStage
    'create a new cStage object (collection)
    Dim objNewMember As cStage
    Set objNewMember = New cStage
    
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing

End Function

Public Property Get Item(varIndexKey As Variant) As cStage
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'varIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant.
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(varIndexKey)
End Property

Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property

Public Sub Remove(varIndexKey As Variant)
    'used when removing an element from the collection
    'varIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)
    mCol.Remove varIndexKey
End Sub

Public Property Let intS4(ByVal vdata As Integer)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.intS4 = 5
    mintS4 = vdata
End Property
Public Property Get intS4() As Integer
    'the SAM4 id for the patch
    'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.intS4
    intS4 = mintS4 '[Removed Set]
End Property

Public Property Let boolD(ByVal vdata As Boolean)
'is this Patch empty?
    mboolDead = vdata
End Property
Public Property Get boolD() As Boolean
    boolD = mboolDead  '[Removed Set]
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    'NewEnum must be hidden in the type library and allocated _
    proc. id -4 (see Tools - Procedure Attributes)
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
  'Set mvarStage = Nothing '[Legacy?]
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub
